import React from 'react';
import ReactDOM from 'react-dom';
import './index.css';
import App from './App';
import registerServiceWorker from './registerServiceWorker';
import { Sensor, TemperatureSensor, PercentSensor, OnOffSensor, HumiditySensor, LightSensor, SwitchSensor, DoorSensor, FanSpeedSensor } from "./sensors.js";

var mqtt = require('mqtt');
var client = mqtt.connect('mqtt://127.0.0.1:8080');
var array_sensors = new Array();

client.on('connect', function () {
  client.subscribe('#');
});

client.on('message', function (topic, message) {
  var array_m = JSON.parse(message);
  array_m.topic = topic.split("/")[1];
  let present = false;

  switch(array_m.type){

    case 'TEMPERATURE':
      present = false;
      for(let i=0; i<array_sensors.length;i++){
        if(array_m.topic === array_sensors[i].name){
          //console.log("present temperature");
          present = true;

          array_sensors[i].addTemperature(array_m.value);
          //set_Box(document.querySelectorAll("[data-name='"+array_sensors[i]._name+"']")[0], array_sensors[i]);
        }
      }
      if(present == false){
        let sensor = new TemperatureSensor({'id':12, 'name':array_m.topic, 'dataSensor':array_m.value})
        array_sensors.push(sensor);
        sensor = sensor_add_url(sensor);
        //addBox("red", "temperature", sensor);
      }
    break;

    case 'ON_OFF':
      present = false;
      for(let i=0; i<array_sensors.length;i++){
        if(array_m.topic === array_sensors[i].name){
          present = true;

          array_sensors[i].setOnOff(array_m.value);
          //set_Box(document.querySelectorAll("[data-name='"+array_sensors[i]._name+"']")[0], array_sensors[i]);
        }
      }
      if(present == false){
        let sensor = new OnOffSensor({'id':12, 'name':array_m.topic, 'dataSensor':array_m.value});
        array_sensors.push(sensor);
        sensor = sensor_add_url(sensor);
        //addBox("orange", "light", sensor);
      }
    break;

    case 'PERCENT':
      present = false;
      for(let i=0; i<array_sensors.length;i++){
        if(array_m.topic === array_sensors[i].name){
          //console.log("present percent");
          present = true;
          array_sensors[i].addPercent(array_m.value);
          //set_Box(document.querySelectorAll("[data-name='"+array_sensors[i]._name+"']")[0], array_sensors[i]);
        }
      }
      if(present == false){
        let sensor = new PercentSensor({'id':12, 'name':array_m.topic, 'dataSensor':array_m.value});
        sensor = sensor_add_url(sensor);
        array_sensors.push(sensor);
        //addBox("green", "eye", sensor);
      }
    break;

    default:

  }
  ReactDOM.render(<App values={array_sensors}/>, document.getElementById('root'));
});

function sensor_add_url(s){
  s._url = s._name.replace(/([A-Z])/g, '_$1').trim().toLowerCase();
  if(s._url.charAt(0) == "_"){
    s._url = s._url.substring(1);
  }
  return s;
}

registerServiceWorker();
